#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
using namespace std;

const int MAXRIC = 100;
const int MAXS = 100;

enum Tipo {Singola, Doppia};

struct Richiesta {
  char nome[MAXS];
  char cognome[MAXS];
  Tipo tipo;
  int punti;
};

struct InsiemeRichieste {
  Richiesta ric[MAXRIC];
  int numRich;
};

bool inserisci(InsiemeRichieste* pi, const char no[], const char co[], Tipo ti, bool fu, float re, float me);
bool alloggioDisponibile(InsiemeRichieste* pi, Tipo ti);
void quantePerTipo(const InsiemeRichieste* pi, int* psing, int* pdop);
bool salvaOrdNome(const InsiemeRichieste* pi, const char nf[]);
bool omonimia(const InsiemeRichieste* pi);

void menu(){
  cout << "----------------------------" << endl;
  cout << "0) stampa contenuto" << endl;
  cout << "1) inserisci richiesta" << endl;
  cout << "2) alloggio disponibile" << endl;
  cout << "3) quante per tipo" << endl;
  cout << "4) salva ord" << endl;
  cout << "5) omonimia" << endl;
  cout << "6) esci" << endl;
  cout << "Scegli: " << endl;
}

Tipo leggiTipo(){
  cout << "Singola o doppia (s/d)? ";
  char c;
  cin >> c;
  if(c=='s' || c == 'S') return Singola;
  return Doppia;
}

bool leggiFuorisede(){
  cout << "Fuorisede (s/n)? ";
  char c;
  cin >> c;
  return c == 's' || c == 'S';
}

void stampaTutto(const InsiemeRichieste* pi){
  for(int i=0; i<pi->numRich; i++){
    cout << pi->ric[i].nome << '\t' << pi->ric[i].cognome << '\t' << pi->ric[i].punti << '\t';
    if(pi->ric[i].tipo == Singola) cout << "Singola" << endl;
    else cout << "Doppia" << endl;
  }
}

int main(){
  InsiemeRichieste ir;
  ir.numRich = 0;

  char nn[MAXS];
  char cc[MAXS];
  float mm;
  float rr;
  Tipo sd;
  bool fuori;
  bool risul;
  int numsing, numdop;

  char s;
  while(true) {
    menu();
    cin >> s;
    switch(s) {
      case '0':
        stampaTutto(&ir);
        break;
      case '1':
          cout << "Inserisci nome: ";
          cin >> nn;
          cout << "Inserisci cognome: ";
          cin >> cc;
          cout << "Inserisci media: ";
          cin >> mm;
          cout << "Inserisci reddito: ";
          cin >> rr;
          sd = leggiTipo();
          fuori = leggiFuorisede();
          risul = inserisci(&ir, nn, cc, sd, fuori, rr, mm);
          if(risul) cout << "Inserimento ok" << endl;
          else cout << "Errore in inserimento" << endl;      
        break;
      case '2':
        sd = leggiTipo();
        risul = alloggioDisponibile(&ir, sd);
        if(risul) cout << "Ho trovato una richiesta compatibile" << endl;
        else cout << "Nessuna richiesta di tale tipo" << endl;
        break;
      case '3':
        quantePerTipo(&ir, &numsing, &numdop);
        cout << "Richieste relative a singole: " << numsing << endl;
        cout << "Richieste relative a doppie: " << numdop << endl;
        break;
      case '4':
        cout << "Provo a salvare in modo ordinato per cognome:" << endl;
        risul = salvaOrdNome(&ir, "out.txt");
        if(risul) {
          cout << "Contenuto del file:";
          system("type out.txt");
        } else cout << "Problemi nel salvataggio" << endl;
        break;
      case '5':
        risul = omonimia(&ir);
        if(risul) cout << "Ci sono casi di omonimia" << endl;
        else cout << "Non ci sono casi di omonimia" << endl;
        break;
      case '6':
        return 0;
    }
  }  
}
