#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
using namespace std;

const int MAXRIC = 100;
const int MAXS = 100;

enum Tipo {Singola, Doppia};

struct Richiesta {
  char nome[MAXS];
  char cognome[MAXS];
  Tipo tipo;
  int punti;
};

struct InsiemeRichieste {
  Richiesta ric[MAXRIC];
  int numRich;
};

int calcolaPunti(bool fuorisede, float reddito, float media){
  int p = 0;
  if(fuorisede) p+=5;
  if(reddito < 10000) p+=5;
  else if(reddito < 20000) p+=2;
  int x = round(media);
  x -= 18;
  p += x;
  return p;
}

bool inserisci(InsiemeRichieste* pi, const char no[], const char co[], Tipo ti, bool fu, float re, float me) {
  if(pi->numRich == MAXRIC) return false;
  Richiesta r;
  strcpy(r.nome, no);
  strcpy(r.cognome, co);
  r.tipo = ti;
  r.punti = calcolaPunti(fu, re, me);
  int i=0;
  for(; i<pi->numRich && r.punti<=pi->ric[i].punti; i++);
  for(int j=pi->numRich; j>i; j--)
    pi->ric[j] = pi->ric[j-1];
  pi->ric[i] = r;
  pi->numRich++;
  return true;
}

bool alloggioDisponibile(InsiemeRichieste* pi, Tipo ti) {
  for(int i=0; i<pi->numRich; i++)
    if(pi->ric[i].tipo == ti){
      for(int j=i; j<pi->numRich-1; j++){
         pi->ric[j] = pi->ric[j+1];
      }
      pi->numRich--;
      return true;
    }
    return false;
}

void quantePerTipo(const InsiemeRichieste* pi, int* psing, int* pdop) {
  *psing = *pdop = 0;
  for(int i=0; i<pi->numRich; i++) {
    if(pi->ric[i].tipo == Singola) (*psing)++;
    else (*pdop)++;
  }
}

void ordina(Richiesta v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++)
      if(strcmp(v[j].cognome, v[index].cognome)< 0)
        index = j;
    Richiesta tmp = v[i];
    v[i] = v[index];
    v[index] = tmp;
  }
}

bool salvaOrdNome(const InsiemeRichieste* pi, const char nf[]) {
  fstream ff;
  ff.open(nf, ios::out);
  if(!ff) return false;
  Richiesta aux[MAXRIC];
  for(int i=0; i<pi->numRich; i++)
    aux[i] = pi->ric[i];
  ordina(aux, pi->numRich);
  for(int i=0; i<pi->numRich; i++) {
    ff << aux[i].cognome << '\t' << aux[i].nome << '\t' << aux[i].punti << '\t';
    if(aux[i].tipo==Singola) ff << "Singola" << endl;
    else ff << "Doppia" << endl;
  }
  return true;
}

bool omonimia(const InsiemeRichieste* pi) {
  for(int i=0; i<pi->numRich; i++) {
    for(int j=i+1; j<pi->numRich; j++)
      if(strcmp(pi->ric[i].nome, pi->ric[j].nome) == 0 && strcmp(pi->ric[i].cognome, pi->ric[j].cognome) == 0)
        return true;
  }
  return false;
}

